.no justify.RIGHT MARGIN 80.OUTPUT width 59;.program
      SUBROUTINE HELP(JTTY)
C     RENBR(/HELP MESSAGE FOR FNDFIL)/M:9999
C
C     DONALD BARTH, HARVARD BUSINESS SCHOOL
C
C     UPPER CASE LETTERS Y AND N FOR YES AND NO
      DATA LTRYYY,LTRNNN/1HY,1HN/
C     LOWER CASE LETTERS Y AND N FOR YES AND NO
      DATA LWRYYY,LWRNNN/1Hy,1Hn/
.BEGIN;.LENGTH 10;.pre       WRITE(JTTY,$)
The FNDFIL  program locates files in  the backup tapes
  of public and private disk packs.
To find which files have been saved,  and to
identify the tapes containing these files,
type what is known about the names of the files and the
[project,programmer] numbers
of the directories in which these were located.
_?#can appear in a name where any single character is allowed. * can appear
if the rest of the name or number can be anything.
Giving *.* as the file name would report about all files.
Include the pack name followed by   _:
if the files were on a private pack.
The file specifications can be entered on as many lines as desired.
Type /GO on the final line to perform the search.
.skip
The following switches can be included with the list of files:
.break
.left margin 8.indent-8
/MMM:YY#to specify the month and year when the files were saved.
MMM is the first 3 letters of the month name and YY is the right 2 digits
of the year number.  If
2 date switches are given, then all dates  between are also searched.
/SKIM and /MMM:YY switches can be issued concurrently.
.indent -8
/CANCEL#to cancel all specifications given so far.
.indent-8
/EXIT###to stop the program.
.indent-8
/GO#####to cause the search to be
performed.
.indent-8
/LIST###to list the specifications which have been entered so far.
.indent-8
/OLD####to include files on monthly tapes which have since been recycled.
.indent-8
/REPEAT#to enter again the same list of specifications searched for last
time.
.indent-8
/SKIM###to search for files on
the current set of daily and weekly skim tapes.
/MMM:YY and /SKIM switches can be issued concurrently.
.left margin 0
.PROGRAM
   90 WRITE(JTTY,91)
   91 FORMAT(' Do you want complete instructions (Y or N)? ',_$)
      READ(JTTY,92)LTRANS
   92 FORMAT(1A1)
      IF(LTRANS.EQ.LTRNNN)GO TO 100
      IF(LTRANS.EQ.LWRNNN)GO TO 100
      IF(LTRANS.EQ.LTRYYY)GO TO 93
      IF(LTRANS.EQ.LWRYYY)GO TO 93
.BEGIN;.pre       WRITE(JTTY,$)
.nofill
Type Y if you want additional information,
  or N to continue running the program.
.fill
.program
      GO TO 90
   93 CONTINUE
.BEGIN;.pre       WRITE(JTTY,$)
The FNDFIL  program locates files in  the backup tapes
  of public and private disk packs.
The directories of the public packs for the most recent  years
 are kept on public
structures and are immediately available.
The ARCH pack must be mounted if  the  directories of the public packs
for earlier years  are to be searched.
The directories of the private packs are only available for the
last month.
.skip
To locate specific files, you must supply to this program
 everything which is
known about the files, including names, directories and
the dates when
the files existed.
This information can either be typed directly into the program, or
can be read from a file if the name of this file is typed with an
 at sign (@) character.
The output will be written onto the  user's terminal
unless the  list of specifications  is preceded by the destination
 file name and an equal sign (=) character.
.skip
An asterisk (*) character  in place of  the file  name, the
   extension or  a  component of the directory  can be matched by
any sequence of characters.
A question mark (?) character  can be used in the file name,
 the  extension or the directory  where any character can appear.
A file name with neither
a period nor  an extension can have any extension.
The period must be included
if the  extension must be blank or  if   the extension is
specified.
.skip
A directory specification must be  enclosed
in square brackets.
Only directories which have the same user (programmer) number
as is running the program can be specified.
 At most one level of sub-file-directory (SFD)  can be
included in the directory specification.
If no SFD is specified, then all SFDs will be searched.
.skip
/MMM:YY or /MMMYY
(where MMM is  a 3 letter month abbreviation,
 such as JAN or FEB, and  where YY
 is the right 2 digits of the year) can be typed to specify the date of
the earliest or latest monthly directory of the public structures which
is to be searched.
If only a single date is specified, then only that month's directory
is searched.
If 2 dates are specified, then this defines the range of dates
to be searched, and
 the most recent is
searched first.
Specifying a date or the /SKIM switch implies that the directories
of the public structures are to be searched.
Do not type a date if
the directory of a private pack is to be searched, just type
the name of the pack without a slash but followed
by a colon.
.skip
The following switches can be typed.
.left margin 8.indent-8
/CANCEL to cancel all specifications given so far.
.indent-8
/EXIT###to stop the program.
.indent-8
/GO#####must be typed after
all specifications have been entered correctly  to cause the search to be
performed.
.indent-8
/LIST###to list the specifications which have been entered so far.
An incorrect item  can be cancelled if it is reentered in its
 incorrect form.
.indent-8
/OLD####to cause files which were
on monthly tapes which have since been recycled to be included.
The directories of sets of tapes which are no longer available
are not searched unless the /OLD switch is issued.

.indent-8
/REPEAT#to enter again the same list of specifications searched for last
time.
The list can be modified, and then /GO can be issued.
.indent-8
/SKIM###to search for files in the directories
of the current set of daily and weekly skim tapes.
A date or date range can also be specified using switches of the form
/MMM:YY
to search for the same files
On the monthly directories of the public structures.
.left margin 0.skip
The following set of commands could be issued to this program to find all files
which have names which include   the letters ABC, or which have  the ABC
extension, in  the directory [1,4] or any of the directories of programmer 56
from December 1978 through May 1979.
The specifications of the matching files would be written into
 the file named OUTPUT.
Although the output file, if stated, must appear first, and the
 /GO must appear last,
 the directories, dates and files to be searched could have
been entered in any order and on any number of lines.
.left margin 5
.nofill
.skip
OUTPUT=[1,4][*,56]ABC*,?ABC*,??ABC*,???ABC,.ABC
/DEC78/MAY:79/GO
.program
  100 RETURN
      END
